package GQ::Server::GBFlat::Adaptor::Feature::inMemoryAdaptor;
use strict;

use vars qw( $AUTOLOAD @ISA );  #Keep 'use strict' happy

use Carp;
use DBI;
use GQ::Root;
use GQ::Server::GBFlat::Adaptor::FeatureAdaptor;
@ISA = qw (GQ::Server::GBFlat::Adaptor::FeatureAdaptor);



{
#Encapsulated class data
#replace with your column names, and sensible defaults

    GQ::Root->create();
### replace this with your table name
    my $_table='';

    # Private table name method
    sub table {$_table}

}
### write in any custom subroutines here


=head1 NAME

inMemoryAdaptor - the adaptor for the Feature::inMemory object

=head1 DESCRIPTION

This does everything the FeatureAdaptor does, but doesn't attempt
to store anything persistently.  This is a nice feature for building
quick, mock features without any database action.

=cut

=head2 update_db,update_discard

 Title   : update_db, update_discard
 Usage   : if ($self->adaptor->update_discard($self)) 
 Function: nothing, since there is not supposed to be a record of this feature
 Returns : 1 for success
 Args    : the inMemory feature being updated


=cut

sub update_db {1}
sub update_discard {1}
sub put_mod_by {1}
sub last_modified {1}


1;

