package GQ::Server::Object;
use strict;
use DBI;
use Carp;
use GQ::Root;

{
	#Encapsulated class data

	                           #    DEFAULT         ACCESSIBILITY
    GQ::Root->create(  context       =>  [undef,        'read/write'],
		       adaptor       =>  [undef,        'read/write'],
		       rootlevel     =>  1,
		    );

}

sub adaptor {
    my ($self,$adaptor) = @_;
    if ($adaptor) {
	$self->{adaptor}=$adaptor;
    }
    return $self->{adaptor};
}

sub _update_db {
    my ($self,$attr,$newval)=@_;
    if ($self->can('table') && $attr) {
	die "Must Acquire Lock On This Region To Proceed.\n"
	  if $self->context->checklock(lockid       => $self->lockid,
				       contig_id    => $self->contig_id,
				       contig_start => $self->contig_start,
				       contig_stop  => $self->contig_stop);
	return $self->adaptor->update_db($self,$attr,$newval);
    } else {
	return 1;
    }
}

1;
